package slimeknights.tconstruct.tools.traits;

import net.minecraft.block.Block;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.monster.EntitySlime;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.world.World;

import java.lang.reflect.InvocationTargetException;

import slimeknights.tconstruct.library.Util;
import slimeknights.tconstruct.library.traits.AbstractTrait;

public class TraitSlimey extends AbstractTrait {

  private static float chance = 0.0033f;

  protected final Class<? extends EntitySlime> slime;

  public TraitSlimey(String suffix, Class<? extends EntitySlime> slime) {
    super("slimey_" + suffix, EnumChatFormatting.GREEN);
    this.slime = slime;
  }

  @Override
  public String getLocalizedName() {
    return Util.translate(String.format(LOC_Name, "slimey"));
  }

  @Override
  public String getLocalizedDesc() {
    return Util.translate(String.format(LOC_Desc, "slimey"));
  }

  @Override
  public void afterBlockBreak(ItemStack tool, World world, Block block, BlockPos pos, EntityLivingBase player, boolean wasEffective) {
    if(wasEffective && !world.field_72995_K && random.nextFloat() < chance) {
      spawnSlime(player, pos.func_177958_n() + 0.5, pos.func_177956_o(), pos.func_177952_p() + 0.5, world);
    }
  }

  @Override
  public void afterHit(ItemStack tool, EntityLivingBase player, EntityLivingBase target, float damageDealt, boolean wasCritical, boolean wasHit) {
    if(!target.func_70089_S() && !target.field_70170_p.field_72995_K && random.nextFloat() < chance) {
      spawnSlime(player, target.field_70165_t, target.field_70163_u, target.field_70161_v, target.field_70170_p);
    }
  }

  protected void spawnSlime(EntityLivingBase player, double x, double y, double z, World world) {
    try {
      EntitySlime entity = slime.getConstructor(World.class).newInstance(world);
      entity.func_70799_a(1);
      entity.func_70107_b(x, y, z);
      world.func_72838_d(entity);
      entity.func_130011_c(player);
      entity.func_70642_aH();
    } catch(InstantiationException e) {
      e.printStackTrace();
    } catch(IllegalAccessException e) {
      e.printStackTrace();
    } catch(InvocationTargetException e) {
      e.printStackTrace();
    } catch(NoSuchMethodException e) {
      e.printStackTrace();
    }
  }

}
